{$u-,x-,v-,r-,c-}

Program Ws_Super;
type
  Str255= String[255];
  Dizi=   Array[1..4096] of byte;
Const
  ScreenMap : Integer = $B800;
var
  Buffer:           Dizi   Absolute $B800:0000;
  Buf:              Dizi;
  Terminator, Mode,
  Secim:            Byte;
  ch:               Char;
  Ekran_No:         Integer;
  Name:             String[14] Absolute Cseg:$80;
  Screen_File,
  WsEkranScr:       File Of Dizi;

 Procedure Print(Mode,x,y: Byte;st: Str255);
 var
   j: Byte;
   i: Integer;

 begin
  i:=(pred(y)*160)+(pred(x)*2);j:=1;
  Repeat
   Mem[ScreenMap:i]:=ord(st[j]);
   Mem[ScreenMap:succ(i)]:=Mode;
   i:=succ(succ(i));j:=succ(j)
  Until j>length(st)
 end; {procedure print}

 Procedure Basla;
 const
       { F3, F4, F5, F6, F7, F8, F9, F10, alt F1, F2, F3, F4, Q, W, E,
         R, T, Y, U, I, O, P, A }

    Character_Byte: Array[1..67] of Byte= (61,62,63,64,65,66,67,68,104,105,
                                           106,107,16,17,18,19,20,21,22,
                                           23,24,25,30,31,32,33,34,35,36,
                                           37,38,44,45,46,84,85,86,87,88,
                                           89,90,91,92,93,94,95,96,97,98,
                                           99,100,120,121,122,123,124,125,
                                           126,127,128,129,108,109,110,111,
                                           112,101);

    Character_Code: Array[1..67] of Byte= (128,135,154,129,152,141,153,
                                           148,158,159,166,167,218,191,
                                           179,192,217,194,195,180,193,
                                           197,196,185,186,187,188,200,
                                           201,202,203,204,205,206,181,
                                           182,183,184,189,190,199,207,
                                           208,209,210,211,212,213,214,
                                           215,216,224,225,227,231,236,
                                           237,248,251,252,253,219,220,
                                           221,222,223,198);

  var
    x,Blok_Basi,
    Blok_Sonu:     Integer;
    Cikis:         Boolean;

  Procedure Ekran_Numarasini_Yaz;
  begin
   Gotoxy(50,25);ClrEol;
   Print(120,50,25,' Ekran No :  ');
   Gotoxy(64,25);Write(Succ(FilePos(Screen_File)))
  end; {procedure ekran numarasini yaz}

  Procedure Space(P1,P2: Integer);
  var  i: Integer;
  begin
   For i:=P1 to P2 do
    if i mod 2=1 then Buffer[i]:=32 else Buffer[i]:=7
  end; {procedure space}

  Procedure Draw_Box(x,y,xuz,yuz: Byte);
  var   i:  Byte;
  begin
   Gotoxy(x,y);Write(#218);
   For i := succ(x) to pred(xuz) do Write(#196); Write(#191);
   For i:=succ(y) to pred(yuz) do
    begin
     Gotoxy(x,i);Write(#179);Gotoxy(xuz,i);Write(#179)
    end;
   Gotoxy(x,yuz);Write(#192);
   For i := succ(x) to pred(xuz) do Write(#196); Write(#217);
  end; {procedure draw box}

  Procedure Tus_Gir(adet:Integer);
  var   i: Byte;
  begin
   if x<3840 then
    begin
     For i:=1 to adet do
      begin
       Buffer[x]:=Terminator;
       x:=succ(x);Buffer[x]:=Mode;x:=succ(x)
      end
    end
   else write(#7)
  end; {procedure tus gir}

  Procedure Return;
  begin
   if x<3680 then x:=succ((160-(x-((x div 160)*160)))+x)
  end; {procedure return}

  Procedure Escape;
  var
    ch: Char;
    i:  Byte;

   Procedure Yukari;
   begin
    if x>160 then x:=x-160 else write(#7)
   end; {procedure yukari}

   Procedure Assagi;
   begin
    if x<3680 then x:=x+160 else write(#7)
   end; {procedure assagi}

   Procedure Sola_Git;
   begin
    if x>2 then x:=pred(pred(x)) else write(#7)
   end; {procedure sola git}

   Procedure Sola_Sil_Git;
   begin
    if x>2 then begin x:=pred(pred(x));Buffer[x]:=32;Buffer[succ(x)]:=Mode end
           else write(#7)
   end; {procedure sola sil git}

   Procedure Saga_Git;
   begin
    if x<3838 then x:=succ(succ(x)) else write(#7)
   end; {procedure saga git}

   Procedure Insert_Space;
   var
     a1,a2: Byte;

   begin
    if x<3838 then
     begin
      a1:=Buffer[3839];a2:=Buffer[3940];
      Move(Buffer[x],Buffer[succ(succ(x))],3838-x);
      Move(Buffer[(succ(x div 160)*160)+2],Buffer[(succ(x div 160)*160)],
           3838-(succ(x div 160)*160)+2);
      Buffer[x]:=32;Buffer[succ(x)]:=7;Buffer[3839]:=a1;Buffer[3840]:=a2
     end
    else write(#7)
   end; {procedure insert space}

   Procedure Delete_Character;
   var
     a1,a2: Byte;

   begin
    if x<3680 then
     begin
      a1:=Buffer[3837];a2:=Buffer[3838];
      Move(Buffer[succ(succ(x))],Buffer[x],3841-succ(succ(x)));
      Move(Buffer[succ(x div 160)*160-2],Buffer[succ(x div 160)*160],
           3838-(succ(x div 160)*160)-2);
      Buffer[3837]:=a1;Buffer[3838]:=a2;
      Buffer[succ(x div 160)*160-1]:=32;Buffer[succ(x div 160)*160]:=7
     end
    else
     if x<3840 then
      begin
       Move(Buffer[succ(succ(x))],Buffer[x],3841-succ(succ(x)));
       Buffer[3840]:=32;Buffer[3841]:=7
      end
     else write(#7)
   end; {procedure delete character}

   Procedure Begin_Of_Line;
   begin
    x:=succ(x-(x mod 160))
   end; {procedure begin of line}

   Procedure End_Of_Line;
   begin
    if (x mod 160)>0 then
     begin
      x:=pred(x+(160-(x mod 160)));
      Repeat  x:=pred(pred(x)) Until (Buffer[succ(x)]<>7) or (x mod 160=1);
      if x mod 160>1 then x:=succ(succ(x))
     end
   end; {procedure end of line}

   Procedure Help_Two; ForWard;
   Procedure Help_One;
   var
     i,Page: Byte;

    Procedure Page_First;
    begin
     For i:=3 to 19 do Space(i*160+3,i*160+(28*2)+1);
     Print(9,3,3,'Funtion Keyboard  :    ');
     Print(14,3,5,'F3  ==>      128');Print(14,3,6,'F4  ==>      135');
     Print(14,3,7,'F5  ==>      154');Print(14,3,8,'F6  ==>      129');
     Print(14,3,9,'F7  ==>      152');Print(14,3,10,'F8  ==>      141');
     Print(14,3,11,'F9  ==>      153');Print(14,3,12,'F10 ==>      148');
     Print(9,3,14,'Alt Function Keyboard  :');
     Print(14,3,16,'F1  ==>      158');Print(14,3,17,'F2  ==>      159');
     Print(14,3,18,'F3  ==>      166');Print(14,3,19,'F4  ==>      167')
    end; {procedure page first}

    Procedure Page_Secont;
    begin
     For i:=3 to 19 do Space(i*160+3,i*160+(28*2)+1);
     Print(9,3,3,'Control Keyboard  :    ');
     Print(14,3,5,'^Y ==> Satr silme');
     Print(14,3,6,'^N ==> Satr ama');
     Print(14,3,7,'^A ==> Sol Kelime');
     Print(14,3,8,'^F ==> Sa Kelime');
     Print(14,3,9,'^R ==> Renk Verme');
     Print(14,3,10,'^J ==> Yatay iz');
     Print(14,3,11,'^K ==> Dik iz');
     Print(14,3,12,'^L ==> Ekran Sil');
     Print(14,3,13,'^I ==> Ekran arma <TAB>');
     Print(14,3,14,'^E ==> Satr Yukar  < '+chr(24)+' >');
     Print(14,3,15,'^X ==> Satr Assag  < '+chr(25)+' >');
     Print(14,3,16,'^S ==> Sola Git      < '+chr(27)+' >');
     Print(14,3,17,'^D ==> Saa Git      < '+chr(26)+' >');
     Print(14,3,18,'^V ==> Boluk Gir    <Ins>');
     Print(14,3,19,'^G ==> Karakter Sil  <Del>')
    end; {procedure page secont}

    Procedure Page_Therth;
    begin
     For i:=3 to 19 do Space(i*160+3,i*160+(28*2)+1);
     Print(14,3,5,'^Q Y ==> Sonuna Kadar Siler');
     Print(14,3,6,'^Q D ==> Kare Ciz');
     Print(14,3,7,'Home ==> Satr Bas');
     Print(14,3,8,'End  ==> Satr Sonu');
     Print(9,3,10,'Save Keyboard          ');
     Print(14,3,12,'^P S ==> Save Et Ekranda');
     Print(14,3,13,'         Kal');
     Print(14,3,14,'^P D ==> Save Et Menye');
     Print(14,3,15,'         Dn');
     Print(14,3,16,'^P X ==> Save Et Sisteme');
     Print(14,3,17,'         Dn');
     Print(14,3,18,'^P Q ==> Save Etmeden');
     Print(14,3,19,'         Menye Dn')
    end; {procedure therth}

    Procedure Page_Forth;
    begin
     For i:=3 to 19 do Space(i*160+3,i*160+(28*2)+1);
     Print(9,3,5,' Alt Kodu Ile : ');
     Print(14,3,6,'1  ==>     224');
     Print(14,3,7,'2  ==>     225');
     Print(14,3,8,'3  ==>     227');
     Print(14,3,9,'4  ==>     231');
     Print(14,3,10,'5  ==>     236');
     Print(14,3,11,'6  ==>     237');
     Print(14,3,12,'7  ==>     248');
     Print(14,3,13,'8  ==>     251');
     Print(14,3,14,'9  ==>     252');
     Print(14,3,15,'10 ==>     253');
    end; {procedure Forth}

    Procedure Page_Five;
    begin
     For i:=3 to 19 do Space(i*160+3,i*160+(28*2)+1);
     Print(9,3,5,' Alt Kodu Ile : ');
     Print(14,3,6,'F5 ==>     219');
     Print(14,3,7,'F6 ==>     220');
     Print(14,3,8,'F7 ==>     221');
     Print(14,3,9,'F8 ==>     222');
     Print(14,3,10,'F9 ==>     223');
     Print(14,3,11,'F10==> Mode    ');
     Print(14,3,12,'               ');
     Print(14,3,13,'               ');
     Print(14,3,14,'               ');
     Print(14,3,15,'               ');
    end; {procedure FIVE}

   begin
    For i:=0 to 22 do Space(succ(i*160),succ(i*160)+60);
    Draw_Box(1,1,30,23);Window(2,2,29,22);
    Print(120,3,1,' Help Level First Table ');
    Page_First;
    Print(9,3,21,'PgUp, PgDn, Any key :');Page:=1;
    Repeat
     Read(kbd,ch);
     if Keypressed then
      begin
       Read(kbd,ch);
       if (ch='I') and (page>1) then Page:=pred(Page)
       else
        if (ch='Q') and (page<5) then Page:=succ(Page)
        else if not (ch in ['I','Q']) then Page:=6;
        if ((ch='Q') and (page<6)) or ((ch='I') and (page>0)) then
         Case Page of
              1:Page_First;
              2:Page_Secont;
              3:Page_Therth;
              4:Page_Forth;
              5:Page_FIVE;
         end;
       if Page<6 then Repeat Until KeypRessed
      end
     else Page:=6
    Until Page=6;
    Window(1,1,80,25)
   end; {procedure help one}

   Procedure Help_Two;
   var
     Buf: Array[1..4096] of Byte;
     i,kemal:      Byte;

    Procedure Page_One;
    begin
     Print(9,21,6,'Alt kodu ile   : ');
     Print(14,21,8,'Q  ==>     218');Print(14,21,9,'W  ==>     191');
     Print(14,21,10,'E  ==>     179');Print(14,21,11,'R  ==>     192');
     Print(14,21,12,'T  ==>     217');Print(14,21,13,'Y  ==>     194');
     Print(14,21,14,'U  ==>     195');Print(14,21,15,'I  ==>     180');
     Print(14,21,16,'O  ==>     193');Print(14,21,17,'P  ==>     197');
     Print(14,21,18,'A  ==>     196')
    end; {procedure page one}

    Procedure Page_Two;
    begin
     Print(9,21,6,'Alt kodu ile   : ');
     Print(14,21,8,'S  ==>     185');Print(14,21,9,'D  ==>     186');
     Print(14,21,10,'F  ==>     187');Print(14,21,11,'G  ==>     188');
     Print(14,21,12,'H  ==>     200');Print(14,21,13,'J  ==>     201');
     Print(14,21,14,'K  ==>     202');Print(14,21,15,'L  ==>     203');
     Print(14,21,16,'Z  ==>     204');Print(14,21,17,'X  ==>     205');
     Print(14,21,18,'C  ==>     206')
    end; {procedure page two}

    Procedure Page_Three;
    begin
     Print(9,21,6,'Shift kodu ile : ');
     Print(14,21,8,'F1 ==>     181');Print(14,21,14,'F7 ==>     199');
     Print(14,21,9,'F2 ==>     182');Print(14,21,15,'F8 ==>     207');
     Print(14,21,10,'F3 ==>     183');Print(14,21,16,'F9 ==>     208');
     Print(14,21,11,'F4 ==>     184');Print(14,21,17,'F10==>     209');
     Print(14,21,12,'F5 ==>     189');Print(14,21,18,'               ');
     Print(14,21,13,'F6 ==>     190')
    end; {procedure Page three }

    Procedure Page_For;
    begin
     Print(9,21,6,'Ctrl kodu ile  : ');
     Print(14,21,8,'F1 ==>     210');Print(14,21,9,'F2 ==>     211');
     Print(14,21,10,'F3 ==>     212');Print(14,21,11,'F4 ==>     213');
     Print(14,21,12,'F5 ==>     214');Print(14,21,13,'F6 ==>     215');
     Print(14,21,14,'F7 ==>     216');Print(14,21,15,'F8 ==>     198');
     Print(14,21,16,'               ');Print(14,21,17,'               ');
     Print(14,21,18,'               ');
    end; {procedure Page for }

   begin
    For i:=4 to 19 do Space(i*160+(19*2),i*160+(42*2));
    Draw_Box(19,4,42,21);Window(20,5,41,20);
    Print(120,20,4,'Help Lev. Second Table');
    Kemal:=1;Page_One;
    Print(9,21,20,'PgUp,PgDn,Any key :');
    Repeat
     Read(kbd,ch);
     if Keypressed then
      begin
       Read(kbd,ch);
       if (ch='I') and (Kemal>1) then Kemal:=pred(Kemal)
       else
        if (ch='Q') and (Kemal<4) then Kemal:=succ(Kemal)
        else if not (ch in ['I','Q']) then Kemal:=5;
        if ((ch='Q') and (Kemal<5)) or ((ch='I') and (Kemal>0)) then
         Case Kemal of
              1:Page_One;
              2:Page_Two;
              3:Page_Three;
              4:Page_For;
         end;
       if Kemal<5 then Repeat Until KeypRessed
      end
     else Kemal:=5
    Until Kemal=5;
    Window(1,1,80,25)
   end; {procedure help two}

   Procedure  Help_tree;
   Var
    NumSt : String[3];
    Ji,Ij : Integer;
   Begin
    Space(1280,3680);
    Ji:=1;
    For Ij:=1 To 20 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,10,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=21 To 40 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,11,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=41 To 60 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,12,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=61 To 80 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,13,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=81 To 100 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,14,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=101 To 120 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,15,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=121 To 140 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,16,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=141 To 160 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,17,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=161 To 180 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,18,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=181 To 200 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,19,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=201 To 220 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,20,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=221 To 240 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,21,NumSt);Ji:=Ji+4;
    End;
    Ji:=1;
    For Ij:=241 To 256 do
    Begin
     Str(Ij:3,NumSt);Print(Ij,Ji,22,NumSt);Ji:=Ji+4;
    End;
    Repeat Until Keypressed;Ch:=' ';
   End;

  begin
   if keypressed then
    begin
     Read(kbd,ch);
     Case ch of
         'H':Yukari;
         'P':Assagi;
         'K':Sola_Git;
         'M':Saga_Git;
         'R':Insert_Space;       { Ins   }
         'S':Delete_Character;   { Del   }
         'G':Begin_Of_Line;      { Home  }
         'O':End_Of_Line;        { End   }
  'q',';','<':begin
              Move(Buffer[1],Buf[1],4096);
              Repeat
               Case ch of
                 ';':Help_One;    { F1    }
                 '<':Help_Two;    { F2    }
                 'q':Help_Tree    {Alt+F10}
               end
              Until not (ch in [';','<','q']);
              Move(Buf[1],Buffer[1],4096)
             end
       else
        begin
         For i:=1 to 67 do
          if ord(ch)=Character_Byte[i] then
           begin Terminator:=Character_Code[i];Tus_Gir(1) end
        end
     end
    end
   else
    Case Terminator of
         19:Sola_git;         { ^S }
          8:Sola_Sil_Git;     { BS }
          4:Saga_Git;         { ^D }
          5:Yukari;           { ^E }
         24:Assagi;           { ^X }
         22:Insert_Space;     { ^V }
          7:Delete_Character  { ^G }
    end
  end; {procedure escape}

  Procedure Delete_Line;
  begin
   if x<3841 then
    begin
     if (Blok_Basi in [x div 160*160..succ(x div 160)*160]) or
        (Blok_Sonu in [x div 160*160..succ(x div 160)*160]) then
             begin
               Blok_Basi:=0;Blok_Sonu:=0
             end
     else
      begin
       if (Blok_Basi>x div 160*160) then Blok_Basi:=Blok_Basi-160;
       if (Blok_Sonu>x div 160*160) then Blok_Sonu:=Blok_Sonu-160
      end;
     x:=succ((x div 160)*160);Move(Buffer[x+160],Buffer[x],3841-x);
     Move(Buffer[3681],Buffer[3841],96);Space(3681,3840)
    end
  end; {procedure delete line}

  Procedure Insert_Line;
  begin
   if (Blok_Basi>x div 160*160) then Blok_Basi:=Blok_Basi+160;
   if (Blok_Sonu>x div 160*160) then Blok_Sonu:=Blok_Sonu+160;
   if (Blok_Basi>3841) or (Blok_Sonu>3841) then
    begin
     Blok_Sonu:=0;Blok_Basi:=0
    end;
   x:=succ(x-(x mod 160));
   Move(Buffer[x],Buffer[succ(x div 160)*160+1],3841-pred(x));
   Space(x,succ(x div 160)*160)
  end; {procedure insert line}

  Procedure Word_Left;
  begin
   if x>1 then
    begin
     Repeat    x:=pred(pred(x))    Until not (Buffer[x]=32);
     Repeat    x:=pred(pred(x))    Until (x=1) or (Buffer[x]=32);
     if x>1 then x:=succ(succ(x))
    end
  end; {procedure word left}

  Procedure Word_Rigth;
  begin
   if x<3841 then
    begin
     Repeat   X:=succ(succ(x))    Until (x=3841) or (Buffer[x]=32);
     if x<3841 then
      Repeat   x:=succ(succ(x))    Until not (Buffer[x]=32);
    end
  end; {procedure wrod rigth}

  Procedure Flash_Mode;
  begin
   Gotoxy(50,25);ClrEol;Print(120,50,25,'Flash Mode = ');
   {$i-}
    Repeat    Gotoxy(63,25);Buflen:=3;Read(Mode)   Until IORESULT=0;
   {$i+}
   Ekran_Numarasini_Yaz
  end; {procedure flash mode}

  Procedure Tusu_Ekrana_Yaz;
  var   i: Byte;

  begin
   if KeypRessed then
    begin
     Read(kbd,ch);
     For i:=1 to 67 do
         if ord(ch)=Character_Byte[i] then
          begin
           Write(chr(Character_Code[i]));Terminator:=Character_Code[i]
          end
    end
   else
    if ord(ch) in [32..127] then
       begin  Write(' ',ch);Terminator:=ord(ch)  end
  end; {procedure tusu ekrana yaz}

  Procedure Yatay_Ciz;
  begin
   ch:=' ';Gotoxy(50,25);ClrEol;
   Print(120,50,25,' Tus = ');Gotoxy(58,25);Read(kbd,ch);
   Tusu_Ekrana_Yaz;
   Repeat
    Tus_Gir(1);Delay(100)
   Until (x=3841) or KeypRessed;
   if KeypRessed then Read(kbd,ch); {Buf i bosalt}
   Ekran_Numarasini_Yaz
  end; {procedure yatay ciz}

  Procedure Dik_Ciz;
  begin
   Gotoxy(50,25);ClrEol;
   Print(120,50,25,' Tus = ');Gotoxy(59,25);Read(kbd,ch);
   Tusu_Ekrana_Yaz;
   Repeat
    Tus_Gir(1);x:=x+158;Delay(150)
   Until (x>3841) or KeypRessed;
   if KeypRessed then Read(kbd,ch) {Buffer i bosalt}
   else x:=x-158;
   Ekran_Numarasini_Yaz
  end; {procedure dik ciz}

  Procedure WindowBox;
  Var
    Buf              : Array[1..160] of Byte;
    XCo,YCo,XLen,
    I,YLen,Clr       : Byte;
    Tmp              : Integer;
    S                : Str255;
  Begin
    Move(Mem[ScreenMap:24 * 160],Buf[1],160); GotoXY(1,25); ClrEol;
    Print(120,1,25,' Color, Column, Lin, Column Len, Lin Len : ');
    GotoXY(44,25); {$I-} Read(Clr,XCo,YCo,XLen,YLen); {$I+}
    If IOresult = 0 Then
    Begin
      Tmp := x; FillChar(S[1],XLen-2,205); S[0] := Chr(XLen-2);
      Print(Clr,XCo,YCo,#201 + S + #187);
      For I := succ(YCo) To pred(YCo + YLen) Do
      Begin
        Print(Clr,XCo,I,#186); Print(Clr,pred(XCo + XLen),I,#186)
      End;
      Print(Clr,XCo,YCo + YLen,#200 + S + #188); x := Tmp
    End;
    Move(Buf[1],Mem[ScreenMap:24 * 160],160)
  End;

  Procedure Screeni_Sil;
  var i: Integer;

  begin
   For i:=1 to 3840 do
     if i mod 2=1 then Buffer[i]:=32 else Buffer[i]:=7;
   x:=1
  end; {procedure screen'i sil}

  Procedure Save_Screen;
  begin
   Gotoxy(1,25);ClrEol;
   Write(Screen_File,Buffer);
  end; {procedure save screen}

  Procedure Screen_Atama;
  var  Difould_Ekran: Integer;

  begin
   Difould_Ekran:=FilePos(Screen_File);
   Print(120,50,25,' Cagrilacak Ekran No : ');Ekran_No:=0;
   {$i-}
    Repeat
     Gotoxy(74,25);BufLen:=2;Read(Ekran_No)
    Until (IOresult=0) and (Ekran_No<=FileSize(Screen_File));
   {$i+}
   Ekran_Numarasini_Yaz;
   if Ekran_No>0 then
    begin
     Seek(Screen_File,pred(Ekran_No));Read(Screen_File,Buf);
     Move(Buf[1],Buffer[1],3841);            { alt satiri atamiyor }
     Seek(Screen_File,Difould_Ekran)
    end
  end; {procedure screen atama}

  Procedure Kontrol_K_Secenekleri;
  var    i: Integer;

   Procedure Blogu_Sakla;
   begin
    Move(Buffer[Blok_Basi],Buf[1],Blok_Sonu-Blok_Basi);
    For i:=Blok_Basi to Blok_Sonu do
        if i mod 2=0 then Buffer[i]:=240
   end;  {procedure blogu sakla}

  begin
   Print(14,75,25,'^K');
   Read(kbd,ch);Terminator:=Ord(Upcase(ch));
   if Terminator in [84,74,75,66,72,67] then Print(14,77,25,ch)
   else
    Case Terminator of
         10:Print(14,77,25,'^T');
         20:Print(14,77,25,'^J');
         11:Print(14,77,25,'^K');
          2:Print(14,77,25,'^B');
          8:Print(14,77,25,'^H');
          3:Print(14,77,25,'^C')
    end;
   Delay(500);Gotoxy(75,25);ClrEol;
   Case Terminator of
          10,84:Yatay_Ciz;                               { ^T,T }
          20,74:Dik_Ciz;                                 { ^J,J }
           2,66:if x<3841 then                           { ^B,B  blok basi   }
                 begin
                  Blok_Basi:=x;
                  if (Blok_Sonu>Blok_Basi) and (Blok_Basi>0) then Blogu_Sakla
                 end;
          11,75:begin                                    { ^K,K  blok sonu   }
                 Blok_Sonu:=x;
                 if (Blok_Sonu>Blok_Basi) and (Blok_Basi>0) then Blogu_Sakla
                end;
           8,72:if (Blok_Basi>0) and (Blok_Sonu>0) then  { ^H,H  Blok kaldir }
                 if (Blok_Sonu>Blok_Basi) then
                  begin
                   Move(Buf[1],Buffer[Blok_Basi],Blok_Sonu-Blok_Basi);
                   Blok_Basi:=0;Blok_Sonu:=0
                  end;
           3,67:if (Blok_Basi>0) and (Blok_Sonu>0) then  { ^C,C  Blok Copy   }
                  if (3841-x) >= (Blok_Sonu-Blok_Basi) then
                    begin
                     Move(Buffer[Blok_Basi],Buffer[x],Blok_Sonu-Blok_Basi);
                     Move(Buf[1],Buffer[Blok_Basi],Blok_Sonu-Blok_Basi);
                     Blok_Sonu:=x+Blok_Sonu-Blok_Basi;
                     Blok_Basi:=x
                    end
   end
  end;  {procedure kontrol K secenekleri}

  Procedure Kontrol_Q_Secenekleri;
  begin
   Print(14,75,25,'^Q');
   Read(kbd,ch);Terminator:=Ord(Upcase(ch));
   if Terminator in [89,68] then Print(14,77,25,ch)
   else
    Case Terminator of
       25 : Print(14,77,25,'^Y');
        4 : Print(14,77,25,'^D')
    end;
   Delay(500);
   Case Terminator of
       25,89 : Space(x,succ(x div 160)*160);  { ^Y,Y }
        4,68 : WindowBox;                     { ^D,D }
   end;
   Gotoxy(75,25);ClrEol
  end;  {procedure kontrol Q secenekleri }

  Procedure Kontrol_P_Secenekleri;
  begin
   Print(14,75,25,'^P');
   Read(kbd,ch);Terminator:=Ord(Upcase(ch));
   if Terminator in [83,68,88,81] then Print(14,77,25,ch)
   else
    Case Terminator of
       19:Print(14,77,25,'^S');
        4:Print(14,77,25,'^D');
       24:Print(14,77,25,'^X');
       17:Print(14,77,25,'^Q')
    end;
    Delay(500);
    Case Terminator of
         19,83:begin                         { ^S,S }
                Save_Screen;
                Seek(Screen_File,pred(FilePos(Screen_File)));
                Print(120,2,25,' File : '+Name+' ');
                Print(120,25,25,' Line  ');
                Print(120,36,25,' Col  ');
                Ekran_Numarasini_Yaz
               end;
          4,68:begin                         { ^D,D }
                Save_Screen;Cikis:=True
               end;
         24,88:begin                         { ^X,X }
                Save_Screen;
                Close(Screen_File);Close(WsEkranScr);
                Halt
               end;
         17,81:Cikis:=True                   { ^Q,Q }
    end
  end;  {procedure kontrol P secenekleri}

 begin
  Terminator:=0;x:=1;Mode:=14;Cikis:=False;Blok_Basi:=0;Blok_Sonu:=0;
  Print(120,2,25,' File : '+Name+' ');
  Print(120,25,25,' Line  ');Print(120,36,25,' Col  ');
  Ekran_Numarasini_Yaz;
  Repeat
   Gotoxy(33,25);Write(succ(x div 160):2);
   Gotoxy(43,25);Write(succ((x mod 160) div 2):2);
   Gotoxy(succ((x mod 160) div 2),succ(x div 160));
   Read(kbd,ch);Terminator:=Ord(ch);
    Case Terminator of
        32..127 : Tus_Gir(1);
             13 : Return;                { ^M }
        19,8,4,7,22,
        5,24,27 : Escape;                { ^[ }
             25 : Delete_Line;           { ^Y }
             14 : Insert_Line;           { ^N }
              1 : Word_Left;             { ^A }
              6 : Word_Rigth;            { ^F }
             18 : Flash_Mode;            { ^R }
             11 : Kontrol_K_Secenekleri; { ^K }
             12 : Screeni_Sil;           { ^L }
              9 : Screen_Atama;          { ^I Tab  screen mov}
             17 : Kontrol_Q_Secenekleri; { ^Q }
             16 : Kontrol_P_Secenekleri  { ^P }
    end
  Until Cikis
 end; {procedure basla}

 Procedure Screen_Print(i: Integer);
 begin
  Seek(Screen_File,pred(i));Read(Screen_File,Buf);
  Move(Buf[1],Buffer[1],4096)
 end;  {procedure screen print}

 Procedure Ekran_Noyu_Al_Listele;
 begin
  ClrScr;Print(120,1,1,' Kac numarali ekrani istiyorsunuz  :  ');
  Ekran_No:=0;
  {$i-}
  Repeat
   Gotoxy(42,1);BufLen:=2;Readln(Ekran_No)
  Until (IOresult=0) and (Ekran_No<=FileSize(Screen_File));
  {$i+}
  if Ekran_No>0 then
   begin
    Screen_Print(Ekran_No);
    Seek(Screen_File,pred(Ekran_No))
   end
 end; {procedure ekran noyu al listele}

 Procedure Load_Screen;
 begin
  Ekran_Noyu_Al_Listele;
  if Ekran_No>0 then Basla
 end;  {procedure load screen}

 Procedure Ekran_Gorme;
 begin
  Ekran_Noyu_Al_Listele;
  if Ekran_No>0 then begin Read(kbd,ch);ch:=' ' end
 end; {procedure ekran gorme}

 Procedure Ekran_Silme;
 var
   Tampon_File:File of Dizi;
   i:          Integer;

 begin
  Ekran_Noyu_Al_Listele;
  if Ekran_No>0 then
   begin
    Print(240,1,25,'  SLME LEMN ONAYLIYORMUSUNUZ  (E/H) ?  :    ');
    {$i-}
     Repeat
      Gotoxy(55,25);BufLen:=5;Read(kbd,ch)
     Until (IOresult=0) and (Ekran_No<=Filesize(Screen_File));
    {$i+}
    if Upcase(ch)='E' then
     begin
      Print(120,60,25,' Ekran no : ');
      Assign(Tampon_File,'WSTAMP.DAT');Rewrite(Tampon_File);
      For i:=0 to pred(FileSize(Screen_File)) do
       if i<>pred(Ekran_No) then
        begin
         Seek(Screen_File,i);Read(Screen_File,Buf);Write(Tampon_File,Buf);
         Gotoxy(73,25);Write(succ(i))
        end;
       Close(Screen_File);Close(Tampon_File);Erase(Screen_File);
       Rename(Tampon_File,Name);
       Reset(Screen_File)
     end
   end
 end;  {procedure ekran silme}

 Procedure Dosyayi_ac;
 var i: Byte;

 begin
  {$i-} Reset(WsEkranScr); {$i+}
  if IOresult<>0 then
   begin
    Writeln;Writeln('Dikkat screen file yok');Halt
   end
  else
   begin
    For i:=1 to length(Name) do if Name[i]=' ' then Delete(Name,i,1);
    For i:=1 to length(Name) do if Name[i]<>' ' then Name[i]:=Upcase(Name[i]);
    Assign(Screen_File,Name);
    {$i-} Reset(Screen_File); {$i+}
    if IOResult<>0 then Rewrite(Screen_File)
   end
 end; {procedure dosyayi ac}

Begin
 Assign(WsEkranScr,'WSEKRAN.SCR');
 if Name<>'' then Dosyayi_Ac
 else
  begin
   ClrScr;Write('Dosya ismi  :');BufLen:=14;Readln(Name);
   Dosyayi_Ac
  end;
 Repeat
  Seek(WsEkranScr,0);Read(WsEkranScr,Buf);Move(Buf[1],Buffer[1],4096);
  {$i-} Repeat  Gotoxy(27,18);BufLen:=2;Read(Secim)  Until IOresult=0; {$i+}
  Case Secim of
       1:begin
          ClrScr;Seek(Screen_File,FileSize(Screen_File));
          Basla
         end;
       2:Load_Screen;
       3:Ekran_Silme;
       4:Ekran_Gorme;
       6:begin
          Close(Screen_File);Close(WsEkranScr);ClrScr;
          Halt
         end
  End
 Until False
End.
