Program Boru;

Const
 Fi = 0.97;
 Qh = 6180;
 Ga = 0.99;
 G  = 9.81;
 L  = 1;
Var
 D,Vu,V,S,Q,Re,Mu,La,F,I,Ro : Real;

Begin
  D  := 0.02125;
  Q  := Qh/20/1000/3600;
  S  := Pi*Sqr(D)/4;
  Vu := 36E-8+((36E-8-29E-8)/10);
  Vu := 36e-8;
  V  := Q/S;
  Re := V*D/Vu;
  If Re <= 2320 Then
    La := 64*Vu/(V*D)
   Else
    La := 0.316/Sqrt(Sqrt(Re));
(*    La:=0.02+(0.0018/(Sqrt(V*D)));*)
  I := (La*L/D)*(Sqr(V)/(2*G))*1000;

  Writeln('Q  :',Q:16:5);
  Writeln('S  :',S:16:5);
  Writeln('Vu :',Vu:16:14);
  Writeln('V  :',V:16:2);
  Writeln('Re :',Re:16:5);
  Writeln('La :',La:16:5);
  Writeln('I  :',I:16:2);
  Writeln('Qh :',Qh:16);
End.